vRP = Proxy.getInterface("vrp")

local open = false
local isNearSlots = false
local isInSlotsGame = false


function DrawAdvanced3DText(x,y,z, text, scl,font,r,g,b,a) 
    local onScreen,_x,_y=World3dToScreen2d(x,y,z)
    local px,py,pz=table.unpack(GetGameplayCamCoords())
    local dist = GetDistanceBetweenCoords(px,py,pz, x,y,z, 1)
 
    local scale = (1/dist)*scl
    local fov = (1/GetGameplayCamFov())*100
    local scale = scale*fov
   
    if onScreen then
        SetTextScale(0.0*scale, 1.1*scale)
        if(font ~= nil)then
            SetTextFont(font)
        else
            SetTextFont(4)
        end
        SetTextProportional(1)

        SetTextColour(r, g, b, a or 255)
        SetTextDropshadow(0, 0, 0, 0, 255)
        SetTextEdge(2, 0, 0, 0, 150)
        SetTextDropShadow()
        SetTextOutline()
        SetTextEntry("STRING")
        SetTextCentre(1)
        AddTextComponentString(text)
        DrawText(_x,_y)
    end
end



function SetOpened(state)
    SetNuiFocus(state, state)
    open = state
end


RegisterNetEvent('slots:client:updateSlots', function(bet)
    SetOpened(true)
    SendNUIMessage({ action = 'open', amount = bet })
end)


RegisterNUICallback('setCoins', function(data, cb)
    cb('ok')
    SetOpened(false)
    TriggerServerEvent('slots:server:checkForMoney', tonumber(data.amount) or 0)
end)


RegisterNetEvent('slots:client:enter', function()
    SetOpened(true)
    SendNUIMessage({ action = 'openAmount' })
end)


RegisterNUICallback('close', function(data, cb)
    cb('ok')
    SetOpened(false)
    TriggerServerEvent('slots:server:payRewards', data.amount)
end)


function IsNearSlots()
    local playerCoords = GetEntityCoords(PlayerPedId(), false)
    local nearestDistance = 2.5
    
    for _, v in ipairs(Config.Slots) do
        local slotsCoords = vector3(v.x, v.y, v.z)
        
        if #(playerCoords - slotsCoords) <= nearestDistance then
            return true
        end
    end
    
    return false
end


Citizen.CreateThread(function()
    while true do
        Citizen.Wait(100) 

        local playerCoords = GetEntityCoords(PlayerPedId(), false)
        local nearestDistance = 2.5  

        isNearSlots = false

        for i, v in ipairs(Config.Slots) do 
            local slotsCoords = vector3(v.x, v.y, v.z)

            if #(playerCoords - slotsCoords) <= nearestDistance then
                isNearSlots = true
                break
            end
        end
    end
end)

Citizen.CreateThread(function ()
    while true do
        Citizen.Wait(0)

        if isNearSlots then
            local playerCoords = GetEntityCoords(PlayerPedId(), false)

            for i, v in ipairs(Config.Slots) do 
                local slotsCoords = vector3(v.x, v.y, v.z)

                if #(playerCoords - slotsCoords) <= 2.5 then
				DrawAdvanced3DText(v.x,v.y,v.z, "Apasa tasta ~g~E~w~ pentru a juca la ~y~BurningHot Slots Machine", 0.5,0,255,255,255,150)


                    if IsControlJustReleased(0, 38) then
                        TriggerEvent('slots:client:enter')
                    end
                end
            end
        end
    end
end)

